
package de.ivu.elect.presentation.gebietsbaum;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.boundary.GebietsgruppierungChangeEvent;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.jee.faces.FacesContextUtil;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.gebietsbaum.form.GebietsgruppierungViewFormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

@OnlineHilfeId("531")
@Named(AbstractGebietsgruppierungEditNoScopeView.COMPONENT_NAME)
public class GebietsgruppierungEditView extends AbstractGebietsgruppierungEditView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient GebietsgruppierungChangeEvent changeEvent;

  @Inject
  private GebietsgruppierungViewFormBuilder viewFormBuilder;

  public GebietsgruppierungEditView() {
    super();
  }

  @Override
  public void addProperties(FormBuilder formBuilder, Gebietsgruppierung gebietsgruppierung) {
    viewFormBuilder.addProperties(formBuilder, gebietsgruppierung);
  }

  @Override
  protected boolean isGebietBearbeitenRechtPruefen() {
    return false;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GEBIETSGRUPPIERUNG_DELETE)
  public String deleteAll() {
    edit.deleteAll(getSelectedWahltermin(), getSelectedWahl());
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getMehrzahlMessage());
    changeEvent.sendChangeEvent(); // ELECT-5585
    return FacesContextUtil.getCurrentViewId();
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GEBIETSGRUPPIERUNG_DELETE)
  public String deleteSearched(List<Gebietsgruppierung> gebietsgruppierungen) {
    edit.deleteSearched(gebietsgruppierungen);

    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getMehrzahlMessage());
    changeEvent.sendChangeEvent(); // ELECT-5585
    return FacesContextUtil.getCurrentViewId();
  }

}
